Lua_SuperVipGiftWindow = class("Lua_SuperVipGiftWindow", Lua_Window);

function Lua_SuperVipGiftWindow:ctor()
	self:superCall("ctor");
    self.windowName = "Lua_SuperVipGiftWindow";
    self.skinName = "SuperVipGiftWindow_skin";
end

function Lua_SuperVipGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardDragItem.new(self.content, 430);
	self.rewardItem.pivot = 1;
	self.rewardItem:setDepth(5);
    self.rewardItem:setLocation(0, 0 ,0);
	
    self.btnGet:addClickFuntion(self, self.onBtnGetClick);
	self.copyText:addClickFuntion(self, self.onCopyClick);

    -- 输入
	self.defaultMsg = LanUtil.getValue(127000);
	self.textInput.defaultText = self.defaultMsg;
	self.textInput.text = ""; 
	local len = DataCenter.chatData.maxMsgLen;
    self.textInput.characterLimit = len;
    self.textInput.maxLineCount = 1;	
    
    -- self:addLuaEvent("PACK_UPDATE", self, self.updateSuperVipGiftInfo);
end

function Lua_SuperVipGiftWindow:showWin(param)
    self.param = param;
    self:updateSuperVipGiftInfo();
end

function Lua_SuperVipGiftWindow:updateSuperVipGiftInfo()
	self.qqAccountText.text = self.param.qqAccount; --QQ账号
	self.gmNameText.text = self.param.gmName; --gm名称

	if self.param.gsBackGiftResidueTime ~= 0 then
		self:updateResidueTime();
	else
		self.timetips:setEnable(false);
	end

	self.rewardItem:setRewardByArray(self.param.backGiftData);

	if self.param.activateType == 0 then
		self.inputBg:setEnable(false);
		self.textInput:setEnable(false);
	else
		self.inputBg:setEnable(true);
		self.textInput:setEnable(true);
	end
end

function Lua_SuperVipGiftWindow:onBtnGetClick()
	-- 请求使用GS礼包
	local actiCode = nil;
	if self.param.activateType == 1 then
		actiCode = self.textInput.text;
	else
		actiCode = "";
	end
	
    DataCenter.packData:sGSBackGift(self.param.id, self.param.index, actiCode);
end

function Lua_SuperVipGiftWindow:onCopyClick()
	if self.qqAccountText.text ~= nil then
		DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.setClipboard, self.qqAccountText.text);
		LanUtil.copyToClipboard(self.qqAccountText.text);  --PC

		OperateAlert.show(LanUtil.getValue(127002));	
	end
end

-- 更新消失时间
function Lua_SuperVipGiftWindow:updateResidueTime()
	local num = self.param.gsBackGiftResidueTime;
	if num <= 0 then
		self:clearTimer();
		return;
	end

	if self.showTimer == nil or self.showTimer == false then
		self.showTimer = true;
		Lua_CommonUtil.addTimer("updateSuperVipGiftTime", 1, self, self.updateSuperVipGiftTime, nil, -1);
	end
	self.timetips.text = LanUtil.formateStr(LanUtil.getValue(127001), TimeTransform.getInstance():transSeconds6(num, true, true));
end

function Lua_SuperVipGiftWindow:updateSuperVipGiftTime()
	local num = self.param.gsBackGiftResidueTime;
	if num <= 0 then
		self:clearTimer();
		self.timetips:setEnable(false);
		return;
	end
	self.timetips.text = LanUtil.formateStr(LanUtil.getValue(127001), TimeTransform.getInstance():transSeconds6(num, true, true));
end

function Lua_SuperVipGiftWindow:clearTimer()
	if self.showTimer ~= nil and self.showTimer == true then
		self.showTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateSuperVipGiftTime);

		self.timetips:setEnable(false);
	end
end

-- 窗口关闭
function Lua_SuperVipGiftWindow:dispose()
	if self.giftDragList ~= nil then
		self.giftDragList:dispose()
		self.giftDragList = nil
	end

	if self.showTimer ~= nil and self.showTimer == true then
		self.showTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateSuperVipGiftTime);
	end

	self:superCall("dispose");
end